;;; mfcalc5.rkt [jpr, pour le cours L3-INFO]
;;; La version finale de TP avec affectation et variables dont @.
;;; Les variables sont stockees avec leurs valeurs dans une table de hash-code.
#lang racket

(require (lib "yacc.ss" "parser-tools"))
(load "mfcalc-lexer-avec-@")

(printf "Generation du mfcalc parser complet. Aucun conflit.
Utilisez des variables, ainsi que les fonctions exp et log et la variable @.\n")

; On maintient les valeurs des variables dans une table de hash-code, plus efficace qu'une A-liste

(define vars (make-hash))

; Definition du parser

(define parse
  (parser

   (start start)                         ; l'axiome de depart
   (end SEMICOLON)                       ; fin d'une analyse sur point-virgule
   (tokens value-tokens op-tokens)
   (error (lambda (a b c) (printf "Parsing error with token ~a\n" b)))

   (precs (nonassoc LOWER_THAN_ELSE)
          (nonassoc else)
          (nonassoc < > <= >= == !=)
          (right =)
          (left - +)
          (left * /)
          (left NEG)
          (right ^))
   
   (grammar
    
    (start [() 'EOF]
           [(expr) (begin (hash-table-put! vars '@ $1) $1)])    ; <----------------------------------
    
    (expr [(NUM) $1]
          [(BOOL) (eq? $1 'true)]
          [(VAR) (hash-table-get vars $1 (lambda () 0))]           ; consultation d'une valeur de variable
          [(VAR = expr) (begin (hash-table-put! vars $1 $3) $3)]   ; modification de la valeur d'une variable
          [(FNCT LPAR expr RPAR) ((eval $1) $3)]                   ; appel de fonction
          [(expr + expr) (+ $1 $3)]
          [(expr - expr) (- $1 $3)]
          [(expr * expr) (* $1 $3)]
          [(expr / expr) (/ $1 $3)]
          [(- expr) (prec NEG) (- $2)]
          [(expr ^ expr) (expt $1 $3)]
          [(expr > expr) (> $1 $3)]
          [(expr >= expr) (>= $1 $3)]
          [(expr < expr) (< $1 $3)]
          [(expr <= expr) (<= $1 $3)]
          [(expr == expr) (equal? $1 $3)]
          [(expr != expr) (not (equal? $1 $3))]
          [(LPAR expr RPAR) $2]
          [(if expr then expr else expr) (if $2 $4 $6)]
          [(if expr then expr) (prec LOWER_THAN_ELSE) (begin (printf "Ah, un THEN sans ELSE !\n") 
                                                             (if $2 $4 (void)))]))))

(define lex (lambda () (get-lexeme (current-input-port))))

(define (parse-one-expr)
  (printf "? ")
  (let ((result (parse lex)))
    (if (not (eq? result 'EOF))
        (begin (printf "==> ~a\n" result) 
               (parse-one-expr)))))

(parse-one-expr)

